/*
    Project: TCGINA
    Version: V1.27
    File   : kfipriv.h

    Copyright (c) 2005-2009 Author of TCGINA DLL. All rights reserved.
    Public Key Fingerprint: 294B A769 4A0A CC05 DAE6 00DD FF47 8C72 4097 67CE

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#ifndef __KFIPRIV_H_D47DF546F16B490bA6D8523603A5594D
#define __KFIPRIV_H_D47DF546F16B490bA6D8523603A5594D

#include "kfi.h"
#include <tomcrypt.h>
#include "secmem.h"
#include "crc32.h"

#define KFI_ITERATION_COUNT  2000
#define KFI_HASH_NAME        "sha512"
#define KFI_HASH_DESC        sha512_desc
#define KFI_CIPHER1_NAME     "twofish"
#define KFI_CIPHER1_DESC     twofish_desc
#define KFI_CIPHER2_NAME     "aes"
#define KFI_CIPHER2_DESC     aes_desc

#define KFI_OFFSET2(s, elem) ((size_t) &((s *)0)->elem)
#define KFI_OFFSET(elem)     KFI_OFFSET2(KFI_DATA, elem)
#define KFI_DATA_OFFSET      KFI_OFFSET(dwSignature)
#define KFI_DATA_ENC_SIZE    (sizeof(KFI_DATA)-KFI_DATA_OFFSET)
#define KFI_DATA_SIZE        KFI_DATA_ENC_SIZE
#define KFI_MESSAGE_OFFSET   KFI_OFFSET(wVersion)
#define KFI_MESSAGE_SIZE     (sizeof(KFI_DATA)-KFI_MESSAGE_OFFSET)
#define KFI_TOTAL_KEY_SIZE   KFI_OFFSET2(KFI_ENCRYPTION_DATA, fValid)

#if KFI_CIPHER_BLOCK_SIZE == 16
#   define KFI_BlockXor(dest, src) \
      ((ULONG64 *)(dest))[0] ^= ((const ULONG64 *)(src))[0]; \
      ((ULONG64 *)(dest))[1] ^= ((const ULONG64 *)(src))[1];
#else
    static void KFI_BlockXor(void *dest, const void *src)
    {
        if ((KFI_CIPHER_BLOCK_SIZE & (sizeof(unsigned)-1)) == 0) {
            unsigned *puDest = (unsigned *)dest;
            unsigned *puDestEnd = puDest +
              KFI_CIPHER_BLOCK_SIZE / sizeof(unsigned);
            const unsigned *puSrc = (const unsigned *)src;
            while (puDest != puDestEnd) {
                *puDest++ ^= *puSrc++;
            }
        } else {
            BYTE *pbDest = (BYTE *)dest;
            BYTE *pbDestEnd = pbDest + KFI_CIPHER_BLOCK_SIZE;
            const BYTE *pbSrc = (const BYTE*)src;
            while (pbDest != pbDestEnd) {
                *pbDest++ ^= *pbSrc++;
            }
        }
    }
#endif

#endif
