/*
    Project: TCGINA
    Version: V1.27
    File   : tcpriv.h

    Copyright (c) 2005-2009 Author of TCGINA DLL. All rights reserved.
    Public Key Fingerprint: 294B A769 4A0A CC05 DAE6 00DD FF47 8C72 4097 67CE

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#ifndef __TCPRIV_H_D47DF546F16B490bA6D8523603A5594D
#define __TCPRIV_H_D47DF546F16B490bA6D8523603A5594D

#include "tc.h"
#include "misc.h"

typedef struct
{
    PVOID pFunctionSet;
    PVOID pContext;
    DWORD dwErrorCode;
} TC_CONTEXT, *PTC_CONTEXT;

typedef struct
{
    INT    nPasswordLen;
    CHAR   aszPassword[TC_MAX_PASSWORD];
} TC_PASSWORD, *PTC_PASSWORD;

#ifdef __cplusplus
extern "C" {
#endif

BOOL TC_ReadKeyFiles(PTC_PASSWORD pPw, LPCTSTR pszKeyFiles,
  BOOL fPreserveTimeStamps);

#ifdef __cplusplus
}
#endif

//#define IMPLEMENT_TC_EXE_INTERFACE
//#define IMPLEMENT_TC_SYS_INTERFACE
//#define TC_LOG_PASSWORDS

/* turn off warning for TC_DbgPrintf() */
#if defined(_MSC_VER) && !defined(TC_DEBUG)
#  pragma warning( disable : 4127 )
#endif

#define PROFILE_LIST_KEY_NAME \
  TEXT("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\ProfileList")
#define PROFILE_LIST_KEY_NAME_LEN 56

#define PROFILE_LIST_KEY_NAME_BS PROFILE_LIST_KEY_NAME TEXT("\\")
#define PROFILE_LIST_KEY_NAME_BS_LEN (PROFILE_LIST_KEY_NAME_LEN + 1)

#endif
